<?php
/**
 * Created by PhpStorm.
 * User: home
 * Date: 2019/6/20
 * Time: 11:48
 */

namespace app\middleware;


use app\controller\Admin;
use app\service\AdminService;
use app\util\ErrorCode;
use app\util\ErrorResponse;
use think\facade\Config;
use think\Request;

class AdminApiCheck
{

    public function handle(Request $request, \Closure $next)
    {
        $token = $request->param('token');//'wxaffadsf31Dfaf93';
        $loginExpired = Config::get("app.admin.expired", 1800);

        if (empty($token)) {
            return ErrorResponse::createError(
                ErrorCode::ERROR_OPENID_REQUIRED, '缺失参数token'
            );
        }
        $token = AdminService::queryToken($token,$loginExpired);
        if(empty($token)){
            return ErrorResponse::createError(
                ErrorCode::USER_NOT_LOGIN, 'user token not exists or not login'
            );
        }
        AdminService::updateToken($token,$loginExpired);
        //对于 admin -> token
        //对于 user -> open_id
        $response = $next($request);
        return $response;
    }
}